#stub function
# @nodoc
STUB = ->
    
# counter used as guid
# @nodoc
TOTAL = 0
    
# entity types registry
# @nodoc
TYPES =((ALL)-> 
    
    r = (id)-> ALL[id]

    r.define = (meta)-> ALL[meta.id] = meta
    
    r.findUnresolved = (typeId) ->

        unless type = ALL[typeId] then typeId else (if type._resolved or !type.superId then null else r.findUnresolved type.superId)

    r.resolve = (typeId, cb) ->

         Object.fire 
         
            uri: 'axoid://require',
         
            dependencies: "entity://#{typeId}", 
            
            callback: (err) ->
                
                throw new Error ("Can't resolve type #{typeId}") unless type = ALL[typeId]
    
                return r.resolve utypeId,cb if (utypeId = r.findUnresolved(typeId))
    
                type._resolved = true
    
                cb()
    
    r

)({})
    
# @nodoc
$ = ((ALL)->
    
    # @nodoc
    class Perceptor
    
        # @nodoc
        class PropHandler
        
            constructor:(@parent, @propId, @fn)->
                reg = @parent.handlers or (@parent.handlers={})
            
                (reg[propId] or (reg[propId] = [])).push @
           
            handle: (ev)->
                try
                    @fn.call null, ev
                catch ex
                    Object.error('notify: '+ex.message).addDetails(Object.update ex, op:(''+@fn).replace(/\n+/g,'')[9..150]).log()
        
            done: ()->
                a.splice(index, 1) if (a = @parent.handlers[@propId]) and ((index = a.indexOf(@)) > -1)
                delete @parent.handlers[@propId] unless a.length
                @parent = @fn = null
        
        constructor: (@id)->
            
        startListen: (@handler)->
            
            if dfrd = @defered
                
                delete @defered
                # fire defered for this key
                Object.log "!!! Fire #{dfrd.length} defered for [#{@id}] "
                @handler ev for ev in dfrd
            
        fire: (ev)->
            
            return @handler(ev) if @handler
                    
            (@defered or (@defered = [])).push ev
            Object.log "!!! Defer fire for [#{@id}]"
                
        addIncomingHandler: (h)->
            
            (@incomings or (@incomings=[])).push h
            
        addPropertyChangedHandler: (propId, fn, targetId)->
         
            h = new PropHandler(@, propId, fn)
            
            $.instance(targetId).addIncomingHandler(h)
            
        #adds an event {#handler} for {#type}
        notifyPropertyChanged : (propId, ev) ->
    
            h.handle ev for h in hh if hh = @handlers?[propId]
    
        done:->
            @handler = @entity = null
            h.done() for h in @incomings if @incomings
            #h.done() for h in hh for propId, hh of @parent.handlers
    
    r = (id)-> ALL[id]
    
    r.instance = (id) ->
        
        ALL[id] or (ALL[id] = new Perceptor(id))
        
    r.release = (id)-> 
        
        if e = ALL[id]
            delete ALL[id]
            e.done()
        e
        
    r

)({})
    

###

    Property class represents logic to access/manipulate a property value of a entity.

    @example  [number] property
    
        Object.fire
            uri: "axoid://define/Property/Number"
    
            methods : ->
                # value comparator
                comparator: (a, b) -> Number(a) is Number(b)
                
                # value setter
                setter: (T, v, ev) -> T[@id] = Number(v)
                
            #It can also mix in entity type attached to.
            mixin:  (_super, prop) ->
                r = {}
                
                propid = prop.id
                
                # add method that increments value of this property
                r['increment'+String.capitalize(propid)] = (delta=1) ->
    
                    # use _super
                    _super.log.call @, "increment #{propid}"
                    
                    @prop propid, ((@prop propid) or 0)+delta
                
                r

###
class Property
    # all properties registry
    ALL = {}
    # property types registry
    PTYPES = {}

    # Binding expression class.
    # @nodoc
    class Property.Expression

        compile: (@message) ->
    
            reg = {}
            src = @sources = []
    
            @body = @message.replace /<(@?[\w\.$ ]+?)>/gm, (s, path)->
                [path,flag] = path.split(' ')
                [id, prop] = if path[0] is '@' then ['@',path[1..]] else path.split(".")
                prop = "value" unless prop
                path = id + "." + prop
                throw new Error ("No id for binding source in #{s}") unless id
                unless reg[path]
                    reg[path] = 1
                    src.push
                        id: path
                        flag: flag
                        entityId: id
                        propId: prop
                "$[\"#{path}\"]"
    
            @expression = (Function.create @body, ['$']) or (->  Object.error("bad-code: Wrong binding expression: #{@body}").log())
            
            @
            
        @instance: (expr)-> (new Expression()).compile(expr) 

    #constructor
    constructor: (@id) ->
        #extract type
        [@id, typeId] = @id.split(':')
        #extract target property name if *Uri
        @asyncTarget = @id[0..-4] if @id[-3..] is "Uri"
        #apply type if is
        if typeId

            throw new Error("ERROR: No such property type: " + typeId)  unless @type = PTYPES[typeId]
            #override methods
            if (ftor = @type.methods) and (methods = ftor(_super = {}))
                for k,v of methods
                    _super[k] = @[k] or STUB if typeof v is "function"
                    @[k] = v

    # invoked when property attached to entity type
    attachToEntityCtor: (ctor) -> Object.update.mixin(ctor::, @type.mixin, @) if @type?.mixin

    # extracts default values at init()
    extractDefaults: (T, defaults) ->

            T[n] = undefined if T[n = @id] and (defaults[n] = T[n])
            T[n] = undefined if T[n = @id+'Expression'] and (defaults[n] = T[n])
            T[n] = undefined if T[n = @id+'Binding'] and (defaults[n] = T[n])

            unless @asyncTarget
                T[n] = undefined if T[n = @id+'Uri'] and (defaults[n] = T[n])
                T[n] = undefined if T[n = @id+'UriExpression'] and (defaults[n] = T[n])

            defaults

    # Property initialization for given entity
    # invoked at entity.init()
    # @param T [Entity] entity instance
    # @param defs [Object] default values
    init: (T, defs) ->

        monitor = locked:false
        #bind expression if any
        Property.bind(T.id, @id, expr, monitor) if (expr = defs["#{@id}Binding"])

        Property.bindWithExpression(T, @id, expr, monitor) if (expr = defs["#{@id}Expression"])

        # set initial value unless none or already bound
        T.prop @id, v, force: true unless ((v = defs[@id]) is undefined) or monitor.bound

        # dynamically init async url if any
        Property.instance("#{@id}Uri").init(T,defs) if (defs["#{@id}Uri"]) or (defs["#{@id}UriExpression"])

    # finalizer for given property. invoked at entity.done()
    done: (T) -> T[@id] = null

    # value getter
    getter: (T) -> T[@id]

    # value setter
    setter: (T, v, ev) -> T[@id] = v

    # value comparator
    comparator: (v1, v2) ->  v1 is v2

    # async value adapter. used in setAsyncValue() callback by default.
    asyncAdapter : (err, value) -> 
        @prop 'asyncError', err if err
        value or null

    createAsyncValueCallback: (T) ->

        T._monitor ?= {} # async locks
        uuid = T._monitor[@id] = Object.math.uuid()

        (err, value) =>
            if  T.isDone

                T.log "!!! obsolete result at asyncValueCallback for property #{T}.#{@id}"
                delete T._monitor[@id]
                return
                
            unless uuid is T._monitor[@id]
            
                T.log "!!! out of monitor at asyncValueCallback for property #{T}.#{@id}"
                return

            T.prop @id, (T["#{@id}AsyncAdapter"] or @asyncAdapter).call(T, err, value)
            delete T._monitor[@id]
            return

    # @set property value.
    # invoked from entity.setProperty()
    # @param [Entity] T target entity instance
    # @param [Any] value value to set
    # @param [Object] opts options. Optional.
    setValue: (T, value, opts) ->

        #narrow to event instance
        ev = Object.update(value: value, opts)

        ev.propId = @id
        ev.entity = T
        ev.oldValue = @getter T

        if ev.uri
            uri = ev.uri
            ev.uri = null

        if ((v = ev.value) isnt undefined) and (ev.force or not @comparator(v, ev.oldValue))

            # persist
            @setter T, v, ev

            # async set for target property
            T.prop(@asyncTarget, null, {uri: v, force: true} ) if @asyncTarget and v

            #callback in T
            T.propertyChanged ev

        #async value
        if uri
            Object.fire 
                uri:uri
                callback: @createAsyncValueCallback(T) 

        ev

    # defines a property type
    @define : (meta) -> PTYPES[meta.id] = meta

    # property instance
    @instance : (id) -> ALL[id] or (ALL[id] = new Property(id))

    ###
        binds property value with expression.
    
        It parses and compiles from given CoffeeScript `expr` containing placeholders in <> brackets.
        
        Placeholder is a source property reference and an optional triggering modifier.
        
        Placeholder grammar:  "<" (entityId|"@") ["." propertyId] [required|optional] ">"
        
        Use "@" to refer taget entity itself
        
        By default, propertyId is "value".
        
        By default, an expression triggers when all sources are defined.
        
        Use `required` modifier to triger only for non-empty source value.
        
        Use `optional` modifier to triger even for undefined source value.
        
        @example hello world
        
            # will trigger only if user.name is defined and not empty
            greetingExpresssion: "'Hello, '+<user.name required>"
            
        @example readyForEvents
        
            # will trigger only if both its own property `dataLoaded` and `other.value` are true
            readyForEventsExpresssion: "<@dataLoaded required> and <other required>"
            
        @example get users list
        
            # will trigger even if search value is undefined yet.
            dataUriExpresssion: "'db://query/users?q='+(<search.value optional> or '')"
            
    ###
    @bindWithExpression : (T, propId, value, monitor) ->

        expr = Property.Expression.instance value

        monitor.locked = false

        _log = (s)-> Object.log "binding: #{T}[#{propId}] #{s}" if Object.DEBUG

        # event handler
        _bind = (ev) ->

            # prevent deadlock
            return  if monitor.locked #_log "Locked"

            values = {}
            for p in expr.sources

                return _log "No source of #{p.id}" unless e = (if p.entityId is '@' then T else $(p.entityId).entity)
                return _log "No value from #{p.id}" if not (val = e.prop(p.propId)) and ((val is undefined and p.flag isnt 'optional') or (p.flag is 'required'))

                values[p.id] = val

            monitor.locked = true

            try

                value = expr.expression.call T, values
                _log "= [#{expr.message}] (#{(''+value).replace('\n',' ')[0..30]})" if Object.LOG_LEVEL>4
                T.prop propId, value

            finally

                monitor.locked = false

        # subscribe to all sources
        $.instance(if ps.entityId is '@' then T.id else ps.entityId).addPropertyChangedHandler(ps.propId, _bind, T.id) for ps in expr.sources

        # perform binding immediately unless already bound from @bindProperty()
        _bind() unless monitor.bound

    ###
        
        double binds property.
        
        Placeholder grammar:  (entityId|"@") ["." propertyId]
        
        Use "@" to refer taget entity itself
        
        By default, propertyId is "value".
        
        Binding triggers when source is defined.
        
        @example hello world
        
            # will trigger when storage.name is defined
            valueBinding: "storage.name"
            
    ###
    @bind: (tId, tProp, path, monitor) ->

        [sId, sProp] = path.split('.')
        sProp = 'value' unless sProp

        _log = (s)-> Object.log "duplex: #{tId}[#{tProp}] #{s}" if Object.DEBUG

        # event handler
        _bind = (ev) ->
            # prevent deadlock
            return  if monitor.locked #_log "Locked"

            monitor.locked = true
            _log "= [#{sId}.#{sProp}] (#{(''+ev.value).replace('\n',' ')[0..30]})" if Object.LOG_LEVEL>4

            try

                throw new Error "Binding target has no id" unless tId
                throw new Error "Lack of binding target with id [#{tId}]" unless e = $(tId)?.entity
                e.prop tProp, ev.value

            finally

                monitor.locked = false

        # subscribe
        $.instance(sId).addPropertyChangedHandler(sProp, _bind, tId)

        unless monitor.reverse

            # perform binding immediately!!!
            if (s0 = $(sId)?.entity) and ((val = s0.prop sProp) isnt undefined)
                _bind(entity:s0, value: val)
                monitor.bound =true

            # bind in reverse
            monitor.reverse=true
            @bind sId, sProp, tId + "." + tProp, monitor

        true

###
    Entity class
    
    @example custom list view

        Object.fire
        
            # extends `D3List`
            uri: "axoid://define/D3List/couch.DbList"
            
            #add property `totalCount` of type `Number`
            properties:['collection','totalCount:Number']
            
            # set totalCount from length of data
            totalCountExpression: '<@data required>.length'
            
            #bind data Uri with expression using `collection` property of itself
            dataUriExpression: "'db://getAll/'+<@collection>"
            
            # methods factory:
            methods:(_super)->
            
                init: ()->
                
                    #use _super
                    _super.init.apply @, arguments
                    ...

                totalCountChanged: (count, event)->
                    ...
        
                dataAsyncAdapter:(err, value)->
                    # try to get data from `items` attribute        
                    value?.items or value or null  


###

class Entity

    # launches entity with cb
    launch: (cb)->
        #calls init()
        @init()
        
        # callback
        cb?(null, @)

    # initializes entity
    init: ->

        #extract all defaults before any p.init()!!!
        defs = {}
        p.extractDefaults @, defs for n, p of @constructor.properties
        
        # init all declared properties
        p.init @, defs for n, p of @constructor.properties
        
        #listen for events of type equals `@id` if has onEvent()
        @listenEvents() if @onEvent
        
        # useful at inline creation
        @onInited?(@)

    # done entity
    done: ->

        # mark done
        @isDone = true

        # done each property
        p.done @ for n, p of @constructor.properties
        
        # remove related 
        $.release @id

    # property get/set
    prop: (key, value, opts) ->

        #prevent after done
        return null if @isDone

        # assigned properties
        p = @constructor.properties

        # as getter (return @[key] if no property defined)
        return (if p[key] then p[key].getter(@) else @[key]) if arguments.length is 1

        # as setter (dynamically assign property if none)
        (p[key] or Property.instance(key)).setValue @, value, opts

        #return value
        value

    # invoked at property changes
    propertyChanged: (ev) ->

        # hooks if defined
        @["#{ev.propId}Changed"]?.call(@, ev.value, ev)

        # notifies listeners
        $(@id)?.notifyPropertyChanged(ev.propId, ev)


    # subscribe to listen events
    listenEvents: () ->
        throw new Error "#{@} attempts to listen events, but has no explicit id" if @id[0] is '#'
        $.instance(@id).startListen((ev)=> @onEvent(ev))

    # error handler
    error: (e, details) ->

        # log
        Object.error(e).addPrefix(@).addDetails(details).log()

    # log
    log : (args...) ->

        return args[0] unless Object.LOG_LEVEL>4
        
        args.unshift @toString()
        Object.log args...
        args[1]

    # toString
    toString: -> if @id[0] is '#' then "[#{@constructor.typeId}:#{@id}]" else "[#{@id}]"

    # get entity constructor or creates/register a new one.
    @getCtor : (meta) -> 
        
        if meta.properties or meta.methods 
        
            @createCtor Object.clone meta,
                id : "T" + (TOTAL++)
                superId: meta.type
                properties: meta.properties or []
                methods: meta.methods
                
        else 
            
            t.ctor or (t.ctor = @createCtor(t)) if (t = TYPES(meta.type))

    #@creates a new one entity constructor.
    @createCtor : (->

        PKEYS = ['id', 'superId','type','properties','methods','callback','uri']

        _applyType = (t, defaults) ->

            # recurrsive supers
            _applyType.call @, TYPES(t.superId), defaults if t.superId

            # add properties
            if t.properties
                for pId in t.properties
                    if @properties[pId]
                        throw Object.error("bad-code: Duplicate property #{pId} in type #{t.id}").log()
                    else
                        (@properties[(p=Property.instance(pId)).id] = p).attachToEntityCtor(@)

            # set defaults
            (defaults[k] = v) for own k, v of t when k not in PKEYS

            # apply methods
            Object.update.mixin @::, t.methods

            @

        (type) ->
            ctor = (meta)->
                
                if id = meta?.id
                    throw new Error ("Duplicate entity id #{id}") if $(id)?.entity
                    @id = id
                    $.instance(@id).entity = @
                else
                    @id = ("##{TOTAL++}") # identity

                @[k] = v for own k, v of meta when k not in PKEYS if meta
                @

            ctor::[k] = v for own k, v of Entity.prototype
            ctor.typeId = type.id
            ctor.properties = {}

            _applyType.call ctor, type, defaults = {}

            ctor::[k] = v for own k, v of defaults

            ctor

    )()
    
    # creates a new instance of entity from given `meta`
    @create:(meta) ->
        
        [meta.id, type] = meta.id.split(':') if meta.id
        
        meta.type = type if type
        
        # check if type presents
        return TYPES.resolve utype, ((err) => @create meta unless err) if (utype = TYPES.findUnresolved(meta.type))
    
        # get constructor
        Ctor = @getCtor(meta)
        # create object
        obj = new Ctor(meta)
        # launch
        obj.launch(meta.callback)
        # return instance
        obj

# Axoid API entity type.
TYPES.define

    id: 'Axoid'
    
    methods:(_super)->
        
        onEvent: (ev)-> @[ev.uri.host](ev)
    
        # defines an entity or property type
        define: (ev, u=ev.uri) -> 
            
            if p = u.path[0]
                ev.id = p 
            
            if p = u.path[1]
                ev.superId = ev.id
                ev.id = p 
            
            if ev.superId is 'Property'
                Property.define ev
            else
                TYPES.define ev
                
            ev.callback()
    
        # creates a new entity instance.
        create: (ev, u=ev.uri) -> 
            ev.id = p if p = u.hash
            ev.type = p if p = u.path[0]
            
            Entity.create ev
            
        # Ensures that all dependencies are once resolved, invokes callback after that.
        require : ( (_cache={})->

            createCb = (ctx) ->
    
                (err, r) ->
                    Object.error(err).log() if err
                    ctx.isDone = 1 unless err
                    cb(err, r) while (cb = ctx.q.shift())
                    1
    
            performRequire = (ev) ->
                
                dependencies = ev.dependencies
                
                dependencies = [dependencies] if typeof dependencies is 'string'
    
                return ev.callback(null, 0) unless dependencies?.length
    
                Function.perform ev,
                    (flow) -> [
                        ->
                            for x in dependencies
    
                                if x and (ctx = _cache[x] or (_cache[x] = q: [], x: x)) and not ctx.isDone
    
                                    ctx.q.push flow.wait()
    
                                    Object.fire {uri:x, callback: createCb(ctx)} if ctx.q.length is 1
    
                            flow.next(null, dependencies.length)
    
                        ev.callback
                    ]
        )()
            
# Axoid API entity instance.
Entity.create {id:'axoid', type:'Axoid'}

###
    Fires an event.
    
    @param [Object] event event object. Required.
    
    @option event uri [Object.Uri] uri referring target entity (which `entity.id` equals to `uri.type`). Required.
    @option event callback [Function] callback to be invoked from target. Optional. Stub by default.

    @example
    
        Object.emit
            # "db" is id of database entity. Rest of url adresses operation and its parameters:
            uri: "db://changes?include_docs=true&since=#{since}"
            callback: (err, result)->
                # handle with results unless errror
                doSome(result) unless err

###
Object.emit = Object.fire = (event) -> 

    throw new Error("No uri specified") unless event.uri

    event.uri = Object.Uri.parse(event.uri)
    event.callback ?= STUB

    $.instance(event.uri.type).fire event
