###
# Defines [EventHandler] entity type that provides featured event handlig.
# @param readyForEventsExpression [Expression]
###
Object.emit 

    uri: "axoid://define/EventHandler"

    properties: ['readyForEvents']

    readyForEventsExpression :'true'

    methods: (_super) ->
        
        # prevent listen event on init()
        listenEvents: ->

        readyForEventsChanged: (ready)->
            #start listen when ready
            _super.listenEvents.call @ if ready

        # listen for Events
        onEvent: (ev) ->
            @dispatchEvent ev

        # resolves operation id from uri
        resolveOperationId: (ev)->
            (ev.method or 'get') + String.capitalize(ev.uri.path[0] or 'default')

        # default Event handler
        dispatchEvent: (ev) ->

            opId = @resolveOperationId ev

            return ev.callback? @error("not-found: Operation not found: #{opId}").log() unless op = @[opId]

            #@log("Dispatch #{ev.uri} into #{opId}") if Object.DEBUG
            try
                op.call @, ev
            catch ex
                ev.callback? @error("Error in #{opId} ").addDetails(ex).log()
